local mod = RW:Boss("The Assembly of Iron", "Ulduar", "Ulduar")
local L

---------------------------
-- Variables
local tOverloadCD, tOverloadCast
local tOverPDur
local tPunchCast
local tRPowerCD, tRPowerCast
local tRDeathCD
local tLightTDur
local tBerserk



---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "The Assembly of Iron"
		
		L.YellPull = "You will not defeat the Assembly of Iron so easily, invaders!"
		end

	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(L.YellPull, 32867, 32927, 32857)
	self:SetWin(32867, 32927, 32857)

	tOverloadCD, tOverloadCast = self:CDTimer(45, 63481), self:CastTimer(6, 63481)
	tOverPDur = self:DurTargetTimer(30, 61888)
	tPunchCast = self:CastTimer(3, 61903)
	tRPowerCD, tRPowerCast = self:CDTimer(30, 61973), self:CastTimer(1.5, 61973)
	tRDeathCD = self:CDTimer(30, 63490)
	tLightTDur = self:DurTimer(30, 61887) -- Duration is total guesswork

	tBerserk = self:BerserkTimer(900)
end

---------------------------
-- Locals

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("Overload", 61869, 63481, 61878)
	self:Track("OverwhelmingPower", 64637, 61888)
	self:Track("FusionPunch", 61903, 63493)
	self:Track("RuneofPower", 61973, 61974)
	self:Track("RuneofDeath", 62269, 63490)
	self:Track("LightningTendrils", 61887, 63486)

	tBerserk:Start()

end

function mod:Overload(event, args)
	if event == "SPELL_CAST_START" then
	 	tOverloadCast:Start()
	end
	if event == "SPELL_CAST_SUCCESS" then
		tOverloadCD:Start()
	end
end

function mod:OverwhelmingPower(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if GetInstanceDifficulty() == 1 then
			tOverPDur:Start(60, args.dName)
		else
			tOverPDur:Start(30, args.dName)
		end
	end
end

function mod:FusionPunch(event, args)
	if event == "SPELL_CAST_START" then
		tPunchCast:Start()
	end
end

function mod:RuneofPower(event, args)
	if event == "SPELL_CAST_START" then
		tRPowerCast:Start()
	end
	if event == "SPELL_CAST_SUCCESS" then
	 	tRPowerCD:Start()
	end
end

function mod:RuneofDeath(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		tRDeathCD:Start()
	end
end

function mod:LightningTendrils(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		tLightTDur:Start()
	end
end
