local mod = RW:Boss("Freya", "Ulduar", "Ulduar")
local L

---------------------------
-- Variables
local tTremorCD, tTremorCast
local tUnstableCD, mUnstable
local tNatureDur, iNature
local iRoots
local tNextAllies
local tSimKill
local tBerserk



---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "Freya"
		
		L.YellPull = "The Conservatory must be protected!"
		L.YellDeath = "His hold on me dissipates. I can see clearly once more. Thank you, heroes."
		L.nextallies_msg = "Wave %d spawning"
		L.nextallies_opt = "Wave count"
		end

	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(L.YellPull, 32906)
	self:SetWin(L.YellDeath, 32906)

	tTremorCD, tTremorCast = self:CDTimer(28, 62859), self:CastTimer(2, 62859)
	tUnstableCD, mUnstable = self:CDTimer(25, 62865), self:TargetMessage(62865)
	tNatureDur, iNature = self:DurTargetTimer(10, 63571), self:Icon("SKULL", 63571, false, 10)
	iRoots = self:Icon("MOON", 62861, false, 20, "SQUARE", "CROSS")
	tNextAllies = self:CustomTimer(60, {L.nextallies_msg, L.nextallies_opt}, 62678)
	tSimKill = self:DurTimer(12, 594)
	tBerserk = self:BerserkTimer(600)
end

---------------------------
-- Locals
local firstKilled = false
local killedCount = 0
local waveCount = 0
local icon = 5

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("GroundTremor", 62859, 62437)
	self:Track("UnstableEnergy", 62451, 62865)
	self:Track("IronRoots", 62861, 62438)
	self:Track("NaturesFury", 62589, 63571)
	self:Track("SummonAlliesofNature", 62678)
--	self:Track("SimKill

	tBerserk:Start()
	
	firstKilled = false
	killedCount = 0
	waveCount = 0
	icon = 5
	
end

function mod:GroundTremor(event, args)
	if event == "SPELL_CAST_START" then
	 	tTremorCast:Start()
	end
	if event == "SPELL_CAST_SUCCESS" then
		tTremorCD:Start()
	end
end

function mod:UnstableEnergy(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		tUnstableCD:Start()
	end
	if event == "SPELL_AURA_APPLIED" then
		mUnstable:Start()		
	end
end

function mod:IronRoots(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if args.destName == UnitName("player") then
			SendChatMessage("Roots on me!", "SAY")
		end
		iRoots:Show(args.dName)
	end
end	

function mod:NaturesFury(event, args)
	if event == "SPELL_AURA_APPLIED" then
		tNatureDur:Start()
		iNature:Show(args.dName)
	end
	if event == "SPELL_AURA_REMOVED" then
		iNature:Hide(args.dName)
	end
end

function mod:SummonAlliesofNature(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		tNextAllies:Start()
		waveCount = waveCount + 1
	end
end

-- function mod:SimKill(event, args)
	